chiark / gitweb /
bin/mdw-build: Do non-VPATH builds.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
82c688c7 13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
b0d8acbe 136 vimrc mg zile
30169591 137 ditz-config
b3468c3b 138 mailrc signature
ce178f96 139 cgrc tigrc
e7d23024 140 gdbinit
8a7e906d 141 guile
1d89ce86 142 rcrc
5d25e440 143 toprc
a6a6806a 144 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
cbffcf2b 145 aspell.conf
78719982 146 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
147 lisp-init.lisp:.cmucl-init.lisp
148 lisp-init.lisp:.sbclrc
149 lisp-init.lisp:.clisprc.lisp
f6335a0c 150 lisp-init.lisp:.eclrc
b5bf3445 151 swank.lisp
2425eca9 152 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 153[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 154 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 155 fonts.conf
e517857c 156 stalonetrayrc
1c6b19d4 157 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 158 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 159 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 160 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 161 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 162 e16-bindings:.e16/bindings.cfg"
f617db13
MW
163echo "Installing dotfiles..."
164for d in $dotfiles; do
739bccbf
MW
165 target=.$d
166 case $d in
167 *:*) target=${d#*:} d=${d%%:*};;
168 esac
169 ft=$HOME$sub/$target
170 dir=${ft%/*}
171 mkdir -p $dir
99063107 172 ln -s $here/dot/$d $ft.new
739bccbf
MW
173 mv $ft.new $ft
174 echo " $target"
f617db13 175done
852cd5fb 176echo " all done."
f617db13 177
403dc178
MW
178## Substitute things which need substituting.
179dotfilessubst="
180 gitconfig
8508a859 181 mykermrc
403dc178
MW
182 pulse-default.pa.in:.pulse/default.pa"
183echo "Installing dotfiles with substitutions..."
184for d in $dotfilessubst; do
185 case $d in
186 *:*) target=${d#*:} d=${d%%:*};;
187 *) target=.$d d=$d.in;;
188 esac
189 ft=$HOME$sub/$target
190 dir=${ft%/*}
191 mkdir -p $dir
192 sed "
2b5d4580
MW
1931i\\
194### generated by $here/setup; do not edit!\\
403dc178
MW
195
196/@home@/ s\a\a$HOME\ag
73165cde 197/@profile@/ s\a\a$here\ag
403dc178 198/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
403dc178
MW
199" dot/$d >$ft.new
200 mv $ft.new $ft
201 echo " $target"
202done
203echo " all done."
204
f4e43257 205## Symlink backgrounds.
960af1a5
MW
206backgrounds="
207 jue-peek.jpg
208 medusa.jpg
5236501e 209 bsg-supper.jpg
960af1a5 210 rayne.jpg
56c871ef 211 hypatia.jpg
e1ca556b
MW
212 noodly.jpg
213 lovelace.jpg"
f4e43257
MW
214if [ "$xstuff" ]; then
215 echo "Installing backgrounds..."
216 for b in $backgrounds; do
217 for e in enlightenment e16; do
218 dir=$HOME$sub/.$e/backgrounds
219 t=$dir/$b
220 mkdir -p $dir
99063107 221 ln -s $here/bg/$b $t.new
f4e43257
MW
222 mv $t.new $t
223 done
224 echo " $b"
225 done
226 echo " all done."
227fi
228
ce178f96
MW
229###--------------------------------------------------------------------------
230### Install useful scripts included in this package.
231
e04c4857 232scripts="
547fb8af 233 mdw-editor
b20bfd83 234 mdw-pager
b056f5c4 235 mdw-conf
7ee12623 236 mdw-build
c4e84cb1 237 emacsclient-hack
8e08f814 238 movemail-hack
aaa2d943 239 sendmail-hack
68b2e9e6 240 aspell-hack
285a1386
MW
241 emerge-hack
242 lesspipe.sh
243 start-ssh-agent
4cdeb0d0 244 svnwrap
73bb9001 245 guest-console
4cdeb0d0 246 hyperspec"
8e08f814 247[ "$xstuff" ] && scripts="$scripts
3bdada49 248 xinitcmd
34a5ea4e 249 un-backslashify-selection
c02999e8 250 lock-screen
8e08f814 251 xshutdown"
e04c4857
MW
252echo "Installing scripts..."
253mkdir -p $HOME$sub/bin
254for s in $scripts; do
255 ft=$HOME$sub/bin/$s
99063107 256 ln -s $here/bin/$s $ft.new
e04c4857
MW
257 mv $ft.new $ft
258 echo " $s"
259done
260echo " all done."
261
4d7d040b
MW
262hacks="
263 ssh:ssh"
264echo "Installing hacks..."
265for h in $hacks; do
266 d=${h%%:*} h=${h#*:}
267 ft=$HOME$sub/bin/hacks/$d
268 mkdir -p $ft
269 ln -s $here/hacks/$h $ft/$h.new
270 mv $ft/$h.new $ft/$h
271 echo " $d:$h"
272done
273echo " all done."
274
ce178f96
MW
275###--------------------------------------------------------------------------
276### Set up the Emacs config.
277
65ff0e8c
MW
278$echon "Finding a suitable emacs:$echoc"
279emacs=no
5fe24792 280for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
281 if type -p >/dev/null $i; then
282 emacs=$i
283 break
284 fi
285done
286if [ $emacs = no ]; then
287 echo " failed."
288 emacs=:
289else
290 echo " $emacs."
291fi
292
f617db13 293echo "Installing Emacs packages..."
400223a1
MW
294emacspkg="
295 make-regexp
a1293ade 296 ew-hols
a3bdb4d9 297 mdw-gnus-patch
1778b496 298 git git-blame vc-git stgit
400223a1
MW
299 quilt"
300for elib in $emacspkg; do
f617db13 301 $echon " $elib:$echoc"
65ff0e8c 302 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 303 (progn
852cd5fb
MW
304 (setq load-path (nconc load-path (list "~/lib/emacs")))
305 (kill-emacs (condition-case nil
306 (progn (load-library "'"$elib"'") 0)
20eb0692 307 (error 1))))'; then
f617db13
MW
308 echo " already installed."
309 else
99063107
MW
310 if [ -f el/$elib.el ]; then
311 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
312 else
313 $echon " downloading$echoc"
314 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
315 fi
f617db13
MW
316 $echon " compiling$echoc"
317 (cd $HOME$sub/lib/emacs;
65ff0e8c 318 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 319 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
320 echo " done."
321 fi
322done
852cd5fb 323echo " all done."
f617db13
MW
324
325$echon "Setting up Emacs configuration:$echoc"
326$echon " linking$echoc"
99063107 327for f in dot-emacs.el Makefile; do
f617db13 328 set -- $(echo $link | tr : ' ')
99063107
MW
329 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
330 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
331done
332$echon " compiling$echoc"
c39d1139 333{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 334echo " done."
ce178f96
MW
335
336###----- That's all, folks --------------------------------------------------